#!/usr/local/bin/perl5.8.0 -w
#
# Designed to pull out any sort of error from the log file 'update_embl.log'
# The log can be rather large so this lets us zero in on problems much more quickly.
#
# Author: Paul Mooney (pjm@sanger.ac.uk)
#
use strict;

my $file              = undef;
my $file_name_printed = 0;

while (<>) {
    if (/FILE:/) {
        $file              = $_;
        $file_name_printed = 0;
    }
    elsif (/ERROR/) {
        print_file_name(\$file_name_printed, $file, $_);
    }
    elsif (/WARNING/) {
        print_file_name(\$file_name_printed, $file, $_);
    }
    elsif (/ClassCastException/) {
        print_file_name(\$file_name_printed, $file, $_);
    }
    elsif (/could not be parsed/) {
        print_file_name(\$file_name_printed, $file, $_);
    }
}

################################################################################
#
#
##
sub print_file_name {
    my ($file_name_printed, $file, $line) = @_;

    unless ($$file_name_printed) {
        print $file;
        $$file_name_printed = 1;
    }

    print $line;
}
