#!/usr/local/bin/perl

use lib "perlLib";
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use ConfigFileReader;
use strict;

$|++;

my $configFilename = "webconfig.conf";

my $cgi = new CGI;
print $cgi->header('text/html');

my %params = $cgi->Vars;

my $write_configFile = $params{WriteConfigFile};
unless ($write_configFile) {
    if (-s $configFilename) {
	## Stomp incoming seettings with existing configFile settings.
	%params = readConfig($configFilename);
    }
}


my $mysql_server = $params{MYSQL_SERVER};
my $mysql_database = $params{MYSQL_DB};
my $mysql_RO_user = $params{MYSQL_READ_ONLY_USER};
my $mysql_RO_password = $params{MYSQL_READ_ONLY_PASSWORD};
my $mysql_RW_user = $params{MYSQL_READ_WRITE_USER};
my $mysql_RW_password = $params{MYSQL_READ_WRITE_PASSWORD};
my $TIGR_url_template = $params{TIGR_URL_TEMPLATE};
my $SANGER_url_template = $params{SANGER_URL_TEMPLATE};

print $cgi->start_html(-title=>"TIGR/Sanger Annotation Comparison Web Portal Administration");



if ($write_configFile) {
    open (CONFIG, ">$configFilename") or die "Can't open $configFilename for writing.\n";
    print CONFIG <<__EOCONFIG__;
## Configuration file for TIGR/SANGER comparison web portal ##

# Mysql settings:
MYSQL_SERVER=$mysql_server
MYSQL_DB=$mysql_database
MYSQL_READ_ONLY_USER=$mysql_RO_user
MYSQL_READ_ONLY_PASSWORD=$mysql_RO_password
MYSQL_READ_WRITE_USER=$mysql_RW_user
MYSQL_READ_WRITE_PASSWORD=$mysql_RW_password

# URLs for linking gene products to TIGR or SANGER production websites
TIGR_URL_TEMPLATE=$TIGR_url_template
SANGER_URL_TEMPLATE=$SANGER_url_template

# end of config file

__EOCONFIG__

    ;
    
    close CONFIG;
    
    print "<font color=\"#FF0000\">Configuration file written.</font><br>\n";

}

print "<center><h1>TIGR/Sanger Compare Administration</h1>\n";

## Print the form:
print <<_EOFORM_;

<form action=admin.cgi method=post>
<table border=0>
<tr><th colspan=2>MySQL Settings</th></tr>
<tr><th align=right>Server name</th><td><input type=text name="MYSQL_SERVER" size=30 value="$mysql_server"></td></tr>
<tr><th align=right>Database name</th><td><input type=text name="MYSQL_DB" size=30 value="$mysql_database"></td></tr>

<tr><td colspan=2>&nbsp;</td></tr>
<tr><th colspan = 2>Usernames and Passwords</th></tr>
<tr><td colspan=2><table border=0 width=100%>
    <tr><th>Read Only</th><td align=center>username <input type=text name="MYSQL_READ_ONLY_USER" size=15 value="$mysql_RO_user"> </td><td align=center>password <input type=password name="MYSQL_READ_ONLY_PASSWORD" size=15 value="$mysql_RO_password"></td></tr>
    <tr><th>Read/Write</th><td align=center>username <input type=text name="MYSQL_READ_WRITE_USER" size=15 value="$mysql_RW_user"></td><td align=center>password <input type=password name="MYSQL_READ_WRITE_PASSWORD" size=15 value="$mysql_RW_password"></td></tr>
    </table></td></tr>

<tr><td colspan=2>&nbsp;</td></tr>    
<tr><th colspan=2>URL Settings</th></tr>
<tr><td colspan=2><table border=0 width=100%>
    <tr><th>TIGR</th><td><input type=text name="TIGR_URL_TEMPLATE" size=100 value="$TIGR_url_template"></td></tr>
    <tr><th>SANGER</th><td><input type=text name="SANGER_URL_TEMPLATE" size=100 value="$SANGER_url_template"></td></tr>
    <tr><td colspan=2 align=center><font size=-1 color="#006666"><i>Place the token</i> <b>__GENE_ID__</b> <i>in the url where the gene identifier would normally occur.</i></font></td>
    </table></td></tr>

<tr><td colspan=2>&nbsp;</td></tr>    
<tr><td colspan=2 align=center><input type=submit value="Write Configuration"></td></tr>

</table>

<input type=hidden name="WriteConfigFile" value=1>
</form>

<p>&nbsp;<p>&nbsp;<p><a href="entryPage.cgi">Enter TIGR/Sanger Annotation Comparison Status Page</a>


_EOFORM_


    ;




print $cgi->end_html();

exit(0);



