#!/usr/local/bin/perl5.8.0

use strict;
use CGI qw/:standard/;



print header,
      start_html('Create & merge EMBL files'),
      h1('Create and merge EMBL files'),
      start_form,
      "\n<TABLE>\n",
      "<TR><TD>Annotation Comparison #</TD><TD>",textfield('number'), "</TD></TR>\n",
      "<TR><TD>Organism </TD><TD>",
      popup_menu(-name   => 'organism',
                 -values => ['T.brucei','L.major']),
      "</TD></TR>\n",
      "<TR><TD>Which updates? </TD><TD>",
      popup_menu(-name   => 'update',
                 -values => ['selected','all']),
      "</TD></TR>\n",
      "</TABLE>\n",
      p,
      submit,
      end_form,
      hr;

if (param()) {
    my $number = param('number');
    my $org    = param('organism');
    my $update = param('update');

    my $org_no_dot      = $org;
    $org_no_dot         =~ s/\.//;
    my $org_base_path   = "/nfs/pathdb/prod/coann/EMBL_FILES/$org_no_dot";
    my $org_log         = "$org_base_path/all_changes.log";
    my $coders_log      = "$org_base_path/update_embl.log";
    my $org_merged_anno = "$org_base_path/annotation.merged";


    my $update_embl = "/nfs/pathdb/prod/coann/bin/update_embl.pl $number $org_no_dot $update";
    my $cmdline     = qq(bsub -q fastblastq -o $coders_log "$update_embl" >/dev/null 2>&1 3>&1 );

    #print "You choose number <B>$number</B>",p, hr;

    print "About to run; <BR />\n<PRE>\n$cmdline\n</PRE>\n<BR />\n";
    print "Please wait, the more files that need to be changed the longer the update will take. <BR />\n";
    print "When the change log appears and has the text <B>*** ALL DONE ***</B> at the end of the file it is safe to cvs commit the changes.\n";

    print "\n<BR />\n";
    print "\n<BR />\n";
    print "Annotators log:  <A HREF=\"file:$org_log\">$org_log</A>\n";
    print "\n<BR />\n";
    print "Programmers log:  <A HREF=\"file:$coders_log\">$coders_log</A>\n";
    print "\n<BR />\n";
    print "Merged EMBL files: <B>$org_merged_anno</B>\n";

    my $output = system( $cmdline );

    if ($output) {
        my $msg = "\n*** ERROR submitting job to LSF ***\n*** command;\n'$cmdline'";
    }
}

print end_html;
