#!/usr/local/bin/perl

use lib "perlLib";
use DBI;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Mysql_connect;
use strict;
use ConfigFileReader;

$|++;

my $cgi = new CGI;
print $cgi->header('text/html');

unless (-s "webconfig.conf") {
    print "Sorry, cannot locate configuration file.  Please create one by visiting the <a href=\"admin.cgi\">admin </a>page.\n";
    exit(1);
}

my %params = readConfig("webconfig.conf");
my $db = $params{MYSQL_DB};
my $user = $params{MYSQL_READ_ONLY_USER};
my $password = $params{MYSQL_READ_ONLY_PASSWORD};
my $server = $params{MYSQL_SERVER};



my ($dbproc) = &connect_to_db($server,$db,$user,$password);

print $cgi->start_html(-title=>"TIGR/Sanger Annotation Comparisons");

print "<a href=\"admin.cgi\">Site administration</a>\n";

print "<CENTER>\n";

print "<h1>Database: $db</h1>\n";



my $query = "select av1.organization, av1.version_name, av1.organism, av2.organization, av2.version_name, ac.annot_compare_id, ac.currentTime from Annotation_version av1, Annotation_version av2, Annot_compare ac where ac.TIGR_annot_stamp_id = av1.annot_stamp_id and ac.SANGER_annot_stamp_id = av2.annot_stamp_id order by ac.annot_compare_id";
my @results = &do_sql_2D($dbproc, $query);

if (@results) {
    print "<table border=1>\n";
    print "<tr><th>Annot Set 1</th> <th>Annot Set 2</th> <th>Organism</th> <th>Annotation Comparison #</th><th>Time of comparison</th></tr>\n";
    foreach my $result (@results) {
	my ($organization1, $version1, $organism, $organization2, $version2, $compare_id, $time) = @$result;
	$compare_id = "<a href=\'showComparisonResults.cgi?db=$db&annot_compare_id=$compare_id\'>$compare_id</a>";
	print "<tr align=center><td>$organization1 ($version1)</td><td>$organization2 ($version2)</td><td>$organism</td><td>$compare_id</td><td>$time</td></tr>\n";

    }

    print "</table>\n";
} else {
    print "Sorry, no annotation comparisons performed yet.\n";
}


print $cgi->end_html();


exit(0);
