# Created by Keith James kdj@sanger.ac.uk
# Port of sh version

# this file is sourced to set CLASSPATH and PATH by scripts that run
# java programs

# set the java version (by setting PATH) and environment (CLASSPATH)
# based on the setting of PSU_PROD_JAVA_VERSION (which should be 1.1,
# 1.2 or 1.3)

if ($?PSU_PROD_JAVA_VERSION) then
  set PSU_MACH=`uname -m`

  if ("$PSU_MACH" == i686 || "$PSU_MACH" == i586) then
      if ("$PSU_PROD_JAVA_VERSION" == 1.4 ||"$PSU_PROD_JAVA_VERSION" == 1.4.1) then
          :
      else
          echo "unknown java version -defaulting to java 1.4.1" 1>&2
      endif
      if (-d /opt/java/) then
          set JAVA_HOME=/opt/java/
      else
          if (-d /usr/java/j2sdk/) then
              set JAVA_HOME=/usr/java/j2sdk/
          else
              echo "can not find a suitable version of Java" 1>&2
          endif
      endif
  else
      switch ($PSU_PROD_JAVA_VERSION)
          case 1.1:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java118
              breaksw
          case 1.2:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java122
              breaksw
          case 1.3:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java131
              breaksw
          case 1.3.1:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java131
              breaksw
          case 1.3.0:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java131
              breaksw
          case 1.4:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java141
              breaksw
          case 1.4.0:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java140
              breaksw
          case 1.4.1:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java141
              breaksw
          case 1.4.2:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java142
              breaksw
          case 1.4.1.2:
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java141_02
              breaksw
          default:
              echo "unknown java version: $PSU_PROD_JAVA_VERSION -defaulting to java 1.1"
              set JAVA_HOME=$BIOSOFT/java/usr/opt/java118
              breaksw
      endsw
  endif

  setenv PSU_ALL_JAR /nfs/pathsoft/prod/javalibs/psu_all.jar

  setenv PATH ${JAVA_HOME}/bin:${PATH}

  # set this to the list of jar files used in production
  setenv PSU_PROD_CLASSPATH `perl -ne 'chomp $_; if (not /^#|^\s*$/) { s/^\s*//; s/\s*$//; push @out, $_ }; END { print (join ":", @out) }' $PSU_CONFIG_DIR/java/java_libs`
else
  echo "error: PSU_PROD_JAVA_VERSION is unset - aborting"
endif
