# Created Tue Aug 28 2001 by Kim Rutherford kmr@sanger.ac.uk
# $Id: java_environment.sh,v 1.14 2004/02/03 17:10:56 kmr Exp $

# this file is sourced to set CLASSPATH and PATH by scripts that run
# java programs

# set the java version (by setting PATH) and environment (CLASSPATH)
# based on the setting of PSU_PROD_JAVA_VERSION (which should be 1.1,
# 1.2 or 1.3)

MACH=`uname -m`

if [ $MACH = i686 -o $MACH = i586 ]
then
  case "$PSU_PROD_JAVA_VERSION" in
      1.4 | 1.4.1)
          ;;
      *)
          if [ "$PSU_PROD_JAVA_VERSION" = "" ]
          then
              echo "warning: PSU_PROD_JAVA_VERSION is unset - defaulting to java 1.4" 1>&2
          else
              echo "unknown java version: $PSU_PROD_JAVA_VERSION -defaulting to java 1.4" 1>&2
          fi
          ;;
  esac
  if [ -d /opt/java/ ]
  then
    JAVA_HOME=/opt/java/
  else
    if [ -d /usr/java/j2sdk/ ]
    then
      JAVA_HOME=/usr/java/j2sdk/
    else
      echo "can not find a suitable version of Java" 1>&2
    fi
  fi
else  
  case "$PSU_PROD_JAVA_VERSION" in
      1.1)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java118
          ;;
      1.2)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java122
          ;;
      1.3 | 1.3.1)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java131
          ;;
      1.3.0)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java131
          ;;
      1.4.0)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java140
          ;;
      1.4.1.2)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java141_02
          ;;
      1.4 | 1.4.1)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java141
          ;;
      1.4.2)
          JAVA_HOME=$BIOSOFT/java/usr/opt/java142
          ;;
      *)
          if [ "$PSU_PROD_JAVA_VERSION" = "" ]
          then
              echo "warning: PSU_PROD_JAVA_VERSION is unset - defaulting to java 1.1" 1>&2
          else
              echo "unknown java version: $PSU_PROD_JAVA_VERSION -defaulting to java 1.1" 1>&2
          fi
          JAVA_HOME=$BIOSOFT/java/usr/opt/java118
          ;;
  esac
fi

PSU_ALL_JAR=/nfs/pathsoft/prod/javalibs/psu_all.jar export PSU_ALL_JAR

export JAVA_HOME

PATH=$JAVA_HOME/bin:$PATH export PATH

# set this to the list of jar files used in production
PSU_PROD_CLASSPATH=`perl -ne 'chomp $_; if (not /^#|^\s*$/) { s/^\s*//; s/\s*$//; push @out, $_ }; END { print (join ":", @out) }' $PSU_CONFIG_DIR/java/java_libs`

export PSU_PROD_CLASSPATH
export PSU_PROD_JAVA_VERSION
