/*
 * This file is part of Gemini. Copyright (c) 2001, 2002 Genome
 * Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.psu.gemini;

import java.io.File;

/**
 * <code>Gemini</code> contains the <code>main</code> method which
 * creates an instance of the <code>GeminiApp</code> class, which is
 * the application itself.
 *
 * @author Keith James
 */
public final class Gemini
{
    public static final String     PROGRAM = "Gemini";
    public static final String     VERSION = "0.20";
    public static final String      AUTHOR = "Keith James (kdj@sanger.ac.uk)";
    public static final String AFFILIATION = "The Wellcome Trust Sanger Institute";

    /**
     * <code>main</code> starts the application.
     *
     * @param argv a <code>String []</code> array.
     * @exception Exception if an error occurs.
     */
    public static void main(String [] argv) throws Exception
    {
        String   query = null;
        String subject = null;
        String    data = null;
        String   chunk = null;

        GeminiApp ga = new GeminiApp();
        ga.startUI();
    }
}
