/*
 * This file is part of Gemini. Copyright (c) 2001, 2002 Genome
 * Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.psu.gemini.gui;

import javax.swing.JToolBar;

final class JToolBarFactory
{
    static final int MAIN = 0;

    private GeminiUI geminiUI;

    JToolBarFactory(GeminiUI geminiUI)
    {
        this.geminiUI = geminiUI;
    }

    JToolBar makeJToolBar(int type) throws Exception
    {
        switch (type)
        {
            // Main toolbar
            case (MAIN):
                return makeMainJToolBar();

            // Bad argument
            default:
                throw new Exception("Invalid JToolBar type requested: " + type);
        }
    }

    private JToolBar makeMainJToolBar()
    {
        JToolBar main = new JToolBar();
        return main;
    }
}
