/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/clu.h>

/**********************************************************************
 *      Name:  clu_get_name
 *   Purpose:  Returns the name of the TruCluster on which this program
 *             is executed.
 *
 * Arguments:  None
 *
 *   Returns:  Cluster name string and exit value 0 on success, exit
 *             value -1 on failure.
 *
 *    Author:  David Harper
 *
 **********************************************************************/

int main(int argc, char **argv) {
    char name[80];
    size_t namelen;
    int rc;

    namelen = sizeof(name);

    rc = clu_info(CLU_INFO_CLU_NAME, name, namelen);

    if (rc != 0) {
        fprintf(stderr, "%s: error %d occurred\n", argv[0], rc);
        return rc;
    }

    printf("%s\n", name);

    return 0;
}
