#!/usr/local/bin/perl5.6.0 -w

# $Header: /nfs/pathsoft/repository/psu/genexec/perl/src/psu_union.pl,v 1.4 2003/09/02 12:31:01 kmr Exp $

# purpose: This script will merge two or more files in any format that EMBOSS
# purpose: supports.

use strict;
use File::Temp qw(tempfile unlink0);

my $do_overlap = 0;

my $emboss_options = "";

my $template = "union_" . $$ . "_XXXXXXXXXXXXX";
my $tmpdir = '/tmp';
my $fh;
my $file_of_filenames;

while (@ARGV && $ARGV[0] =~ /^-(.+)/) {
  shift;
  if ($1 eq "o") {
    $do_overlap = 1;
  } else {
    $emboss_options .= " -$1";
  }
}

sub usage
{
  die <<EOF;
usage: $0 [emboss options] files_to_join ...
   or: $0 [emboss options] \@file_of_filenames
EOF
}

if (@ARGV == 1 && $ARGV[0] =~ /^@/) {
  $file_of_filenames = $ARGV[0];
  $file_of_filenames =~ s/^\@//;
}

if (@ARGV && !defined $file_of_filenames) {
  ($fh, $file_of_filenames) = tempfile($template, DIR => $tmpdir)
    or die "Can't create temporary file in $tmpdir: $!";

  for my $file (@ARGV) {
    print $fh "$file\n";
  }
}

my $arg_file_name = "";

if (defined $file_of_filenames) {
  $arg_file_name = "\@$file_of_filenames";
} else {
  print STDERR "(reading from standard input)\n";
}

system "$ENV{PSU_EMBOSS}/bin/union -filter -auto -feature -source -osf embl $emboss_options $arg_file_name";
