#!/usr/local/bin/bash

# purpose: This script checks the cluster machines to make sure they are
# purpose: alive and that they can see important directories like
# purpose: ~yeastpub and ~pubseq

PATH=/usr/local/lsf/bin/:$PATH

if [ "$1" = -quiet ]
then
    quiet=t
else
    quiet=f
fi

dirs_to_check=`echo ~pubseq/blastdb ~yeastpub/people /usr/local/bin /nfs/disk222/yeastpub2/pathogen/ /nfs/disk222/yeastpub3/quota.user ~kmr/src ~sdb/.cshrc ~ftp/pub/pathogens ~ftp/pub/pathogens/software /nfs/WWW/htdocs ~malaria/MAL1 ~dicty/DICTY1 ~leishpub/analysis`

machines=`lshosts -R blast | /usr/local/bin/perl -ne 'split; print "$_[0] " if (2..999999) ' | sort`

machines="$machines maul darth yoda sith fes1 fes6 fes18 fes26"

for mach in $machines
do
    lsrun -m $mach date > /dev/null &

    sleep 15

    problem_found=f

    # if the machine is alive this kill will fail
    if kill $! > /dev/null 2>&1
    then
        echo "$mach: job placement failed"
        problem_found=t
    else
        # job finished before we killed it so try doing something useful

        for dir in $dirs_to_check
        do 
            if ! lsrun -m $mach ls $dir > /dev/null 2>&1
            then
                echo $mach: `dirname $dir`" is missing "
#                lsrun -m $mach ls $dir

                problem_found=t
            fi
        done
    fi

    if [ $quiet = f ]
    then
        if [ $problem_found = f ]
        then
            echo "$mach: OK"
        fi

        echo
    fi
done

if [ $quiet = f -a `lsload | grep -v ' ok ' | grep -v ' lockW ' | wc -l` != 1 ]
then
    echo
    lsload | grep -v ' ok ' | grep -v ' lockW '
fi
