#!/bin/sh

# purpose: This script makes a contiguous embl file from overlapping entries.

usage () {
   echo "usage: $0 embl_file ..."
   echo
   echo "The output (written to standard output) is an embl file that has been"
   echo "made by merging all the argument entries"

   exit 1
}


if [ $# = 0 ]
then
   usage
fi

PATH=$PATH:`dirname $0`

temp_entry=$1

temp_file="/tmp/contig_maker.$$.tmp";

cp $1 $temp_file

echo "first entry $1" 1>&2

shift

rm -f $temp_file.overlap

for i in $*
do
  echo "now joining $i to the contig" 1>&2
  if embl_join.pl $temp_file $i > ${temp_file}_new
  then
    mv ${temp_file}_new $temp_file
    cat overlap.tab >> $temp_file.overlap
  else
    echo "failed to add $i to the contig" 1>&2
    exit 1
  fi
done

cat $temp_file

mv $temp_file.overlap overlap.tab

rm -f $temp_file
