#!/bin/sh

# $Header: /nfs/pathsoft/repository/psu/genexec/shell/src/restrict_all.sh,v 1.1 2000/03/01 15:34:10 kmr Exp $

# purpose: Creates a .tab file for each common restriction enzyme from a given
# purpose: sequence.
# purpose: These are the enzymes:
# purpose: HindIII BamHI EcoRI NotI XbaI SalI SacI SacII AseI SfiI
# purpose: PstI ClaI NruI MluI KpnI SmaI Sau3AI MspI HpaII XhoI PvuI PvuII AluI
# purpose: BglII DpnI MboII MboI NarI DraI PacI PmeI EagI EcoRV HincII AccI
# purpose: SphI SwaI

if [ $# = 0 ]
then
    echo need a sequence file as argument 1>&2
    exit 1
fi

enzymes="HindIII BamHI EcoRI NotI XbaI SalI SacI SacII AseI SfiI PstI ClaI NruI MluI KpnI SmaI Sau3AI MspI HpaII XhoI PvuI PvuII AluI BglII DpnI MboII MboI NarI DraI PacI PmeI EagI EcoRV HincII AccI SphI SwaI"

for enzyme in $enzymes
do
    name=restrict_$enzyme.tab
    restrict_to_tab.pl -enzymes $enzyme $1 2>&1 > $name | 
        grep -v '^$' | grep -v '^Scanning '
    if [ -s $name ]
    then
        :
    else
        rm $name
    fi
done

