#!/bin/sh
# Wrapper for converting TigrXML to HTML
# Usage: tigr2html <XML file> <HTML file>
# Requires the correct DTD in the directory specified by the XML file

PSU_PROD_JAVA_VERSION=1.3

# PSU_CONFIG_DIR is set in ~yeastpub/.cshrc

# set java version and $PSU_PROD_CLASSPATH
. $PSU_CONFIG_DIR/shell/java_environment.sh

CLASSPATH=$PSU_PROD_CLASSPATH:$PATHSOFT/external/javalib/xalan-2.3.1.jar:$PATHSOFT/external/javalib/xml-apis.jar
export CLASSPATH

usage () {
   echo "Usage: $0 <XML file> <HTML file>"
   echo
   echo "The output is written to HTML file. Requires the correct DTD"
   echo "in the directory specified by the XML file."

   exit 1
}

if [ $# = 0 ]
then
   usage
fi

java org.apache.xalan.xslt.Process -IN $1 -OUT $2 -XSL $PATHSOFT/prod/psu_cvs/tigrxml/xsl/src/tigr2html.xsl
