/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.util.gui;

/**
 * <code>NoSuchImageException</code> is an exception thrown when an
 * attempt is made to retrieve an <code>Image</code> which is not
 * available, either because it does not extist, or because an invalid
 * identifier was used.
 *
 * @author Keith James
 */
public class NoSuchImageException extends Exception
{
    /**
     * Creates a new <code>NoSuchImageException</code>.
     */
    public NoSuchImageException()
    {
        super();
    }

    /**
     * Creates a new <code>NoSuchImageException</code> with the
     * supplied message.
     *
     * @param message a <code>String</code>.
     */
    public NoSuchImageException(String message)
    {
        super(message);
    }
}
