/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.psu.sql;

import java.sql.Connection;

import junit.framework.TestCase;

public class ConnectionFactoryDefaultImplTest extends TestCase
{
    private ConnectionFactory factory;
    private Connection        connection;

    private String     user = "jobs";
    private String password = "pathjobs";

    public ConnectionFactoryDefaultImplTest(String name)
    {
        super(name);
    }

    public void setUp() throws Exception
    {
        factory = new ConnectionFactoryDefaultImpl(user, password);
    }

    public void tearDown()
    {
        factory.close(connection);
    }

    public void testGetConnection() throws Exception
    {
        connection = factory.getConnection();
    }
}
