package uk.ac.sanger.psu.gfmerge.analysis;

import java.util.*;

/** interface for all feature analysis classes
 *
 * @author Sebastian R. Spiegler
 * @version 1.0
 */
public interface BasicFeatureAnalysisAble
{
  /** stub for method which returns high scoring path of genemodels on the sequence
   *
   * @param _arrListOfGMRegionsToAnalyze ArrayList of genemodel regions
   * @return ArrayList of regions with high scoring genemodels
   */
  public ArrayList getHighScoringGmRegArr(ArrayList _arrListOfGMRegionsToAnalyze);
  /** stub for method which returns class name without package information
   *
   * @return class name without package information
   */
  public String getClassName();
}
