package uk.ac.sanger.psu.gfmerge.analysis.simfeature_analysis;

import java.util.*;
import java.io.*;
import java.util.regex.*;

import org.biojava.bio.*;
import org.biojava.bio.seq.*;
import org.biojava.bio.symbol.*;
import org.biojava.bio.seq.impl.*;
import org.biojava.bio.seq.io.*;

import uk.ac.sanger.psu.gfmerge.datacomp.*;
import uk.ac.sanger.psu.gfmerge.util.io.*;
import uk.ac.sanger.psu.gfmerge.util.getopt.*;
import uk.ac.sanger.psu.gfmerge.util.biotools.*;
import uk.ac.sanger.psu.gfmerge.util.algotools.*;
import uk.ac.sanger.psu.gfmerge.util.debug.*;
import uk.ac.sanger.psu.gfmerge.analysis.*;
import uk.ac.sanger.psu.gfmerge.analysis.simfeature_analysis.*;
import uk.ac.sanger.psu.gfmerge.analysis.simfeature_analysis.tools.*;

/** Abstract class which contains partial implementation of derived overlap analysis classes
 * 
 * @author Sebastian R. Spiegler
 * @version 1.0
 */
public abstract class FeatureOverlapAnalysis extends FeatureAnalysis
{

  ///////////////////////////////////////
  // attributes
  /** ArrayList of genemodel regions
   */
  private ArrayList arrListOfGMRegions;
  /** ArrayList of SimFeature regions
   */
  private ArrayList arrListOfFeatRegions;
  /** SimpleArg object which contains all command line arguments
   */
  private SimpleArg allArguments;

  ///////////////////////////////////////
  // constructor
  /** constructor of abstract FeatureOverlapAnalysis class, contains partial implementation of constructors of derived overlap analysis classes
   * 
   * @param _arrListOfGMRegions ArrayList of genemodel regions
   * @param _arrListOfFeatRegions ArrayList of SimFeature regions
   * @param _allArguments SimpleArg object which contains all command 
   *     line arguments
   */
  public FeatureOverlapAnalysis(ArrayList _arrListOfGMRegions,
                                ArrayList _arrListOfFeatRegions,
                                SimpleArg _allArguments)
  {
    super(_arrListOfGMRegions,_arrListOfFeatRegions, _allArguments);
  }
}
