package uk.ac.sanger.psu.gfmerge.analysis.simfeature_analysis.tools;

import java.util.*;

import org.biojava.bio.symbol.*;

import uk.ac.sanger.psu.gfmerge.datacomp.*;
import uk.ac.sanger.psu.gfmerge.util.algotools.*;
import uk.ac.sanger.psu.gfmerge.util.debug.*;

/** class which contains all computing tools for AvgCondProbAnalysis
 * 
 * @author Sebastian R. Spiegler
 * @version 1.0
 */
public class AvgCondProbAnalysisTools /*extends BasicFeatureAnalysisTools*/
{

  /** method which returns a hash of genemodels pointing to their score
   * 
   * @param debug debuggin mode
   * @param _arrListOfGMRegions ArrayList of genemodel regions
   * @return HashMap of genemodels pointing to their score
   */
  public static HashMap getAcpScoredGmHash(int debug,
                                           ArrayList _arrListOfGMRegions)
  {
    HashMap acpScoredGmHash = new HashMap();

    for(Iterator itReg = _arrListOfGMRegions.iterator(); itReg.hasNext();)
    {
      GFMergeRegion region = (GFMergeRegion) itReg.next();
      ArrayList gmArr      = (ArrayList) region.getLocateable();

      for (Iterator itGm = gmArr.iterator(); itGm.hasNext(); )
      {
        GeneModel gm = (GeneModel) itGm.next();
        double acp = gm.getPrediction().getGenePredicter().getAcp();
        acpScoredGmHash.put(gm, new Double(acp));
      }
    }
    return acpScoredGmHash;
  }
}
