package uk.ac.sanger.psu.gfmerge.analysis.simfeature_analysis.tools;

import java.util.*;

import org.biojava.bio.symbol.*;

import uk.ac.sanger.psu.gfmerge.datacomp.*;
import uk.ac.sanger.psu.gfmerge.util.algotools.*;
import uk.ac.sanger.psu.gfmerge.util.debug.*;

/** class which contains computing tools for CDnaSpliceSiteAnalysis.
 * 
 * @author Sebastian R. Spiegler
 * @version 1.0
 */
public class GeneModelLengthAnalysisTools /*extends BasicFeatureAnalysisTools*/
{
  /** method which returns HashMap of genemodels pointing to their score using genemodel length (intron + exon length) as scoring system.
   * 
   * @param debug debugging mode
   * @param _arrListOfGMRegions ArrayList of genemodel regions
   * @return HashMap of genemodels pointing to their genemodel length score
   */
  public static HashMap getGmLengthScoredGmHash(int debug,
                                                ArrayList _arrListOfGMRegions)
  {
    HashMap gmLengthScoredGmHash = new HashMap();

    for(Iterator itReg = _arrListOfGMRegions.iterator(); itReg.hasNext();)
    {
      GFMergeRegion region = (GFMergeRegion) itReg.next();
      ArrayList gmArr      = (ArrayList) region.getLocateable();

      for (Iterator itGm = gmArr.iterator(); itGm.hasNext(); )
      {
        GeneModel gm   = (GeneModel) itGm.next();
        long gmLength  = gm.getLength();
        gmLengthScoredGmHash.put(gm, new Double(gmLength));
      }
    }
    return gmLengthScoredGmHash;
  }
}
