package uk.ac.sanger.psu.gfmerge.datacomp;

/** This typesafe enumeration construct replaces primitive constants
 * with a set of static final object references encapsulated in this class
 * that restricts further instantiation.
 *
 * @author Sebastian R. Spiegler
 * @see uk.ac.sanger.psu.gfmerge.datacomp.Exon
 * @see uk.ac.sanger.psu.gfmerge.datacomp.FeatureComponentAble
 * @version 1.0
 */

public final class ExonType {

  ///////////////////////////////////////
  // attributes

  private final String name;

  ///////////////////////////////////////
  // operations
  /** @param name
   */
  private ExonType(String name) {
    this.name = name;
  }

  public String toString() {
    return name;
  }

  public static final ExonType
      TYPE_5_END = new ExonType("TYPE_5END"),
      TYPE_3_END = new ExonType("TYPE_3END"),
      TYPE_INTERNAL = new ExonType("TYPE_INTERNAL"),
      TYPE_SINGLE_EXON_GENE = new ExonType(" TYPE_SINGLE_EXON_GENE");
}