package uk.ac.sanger.psu.gfmerge.datacomp;

import java.util.*;
import org.biojava.bio.symbol.*;

import uk.ac.sanger.psu.gfmerge.util.biotools.*;
import uk.ac.sanger.psu.gfmerge.util.algotools.*;

/** class which represents a cluster of overlapping features on a sequence.
 *
 * @author Sebastian R. Spiegler
 * @version 1.0
 */
public class GFMergeRegion {//implements LocateAble{

  ///////////////////////////////////////
  // attributes

    /** cluster location
     */
    private Location location;
    /** ArrayList of features objects (implementing LocateAble interface)
     */
    private ArrayList locatable;            // array list of LocateAble objects

   ///////////////////////////////////////
   // constructor

   /** constructor of GFMergeRegion objects
    *
    * @param _location location of the cluster
    * @param _locateable overlapping features within the cluster
    */
   public  GFMergeRegion(Location _location, ArrayList _locateable)
   {
     setLocation(_location);
     setLocateable(_locateable);
   } // end Region


  ///////////////////////////////////////
  // operations

    /** accessor method which returns location of the cluster
     *
     * @return location of the cluster
     */
    public Location getLocation()
    {
        return location;
    } // end getLocation

    /** accessor method which sets location of the cluster
     *
     * @param _location location of the cluster
     */
    private void setLocation(Location _location)
    {
        location = _location;
    } // end setLocation

    /** accessor method which returns ArrayList of overlapping features in cluster
     *
     * @return ArrayList of overlapping features in cluster
     */
    public ArrayList getLocateable()
    {
        return locatable;
    } // end getGeneModels

    /** accessor method which sets ArrayList of overlapping features in cluster
     *
     * @param _locateable ArrayList of overlapping features in cluster
     */
    private void setLocateable(ArrayList _locateable)
    {
        locatable = _locateable;
    } // end setGeneModels

} // end Region
