package uk.ac.sanger.psu.gfmerge.datacomp;

import org.biojava.bio.symbol.*;

/** class Intron is representing an biological intron which is the Location inbetween two sublocation of a feature.
 * <p>
 * For example:
 * <pre>
 * Intron intron = new Intron(geneModel, location);
 * </pre>
 * 
 * @author Sebastian R. Spiegler
 * @see uk.ac.sanger.psu.gfmerge.datacomp.Exon
 * @see uk.ac.sanger.psu.gfmerge.datacomp.FeatureComponent
 * @see uk.ac.sanger.psu.gfmerge.datacomp.ExonAble
 * @version 1.0
 */


public class Intron extends FeatureComponent implements IntronAble {

  ///////////////////////////////////////
  // attributes


  ///////////////////////////////////////
  // operations

    /** constructor for Intron objects
     * 
     * @param _gfmFeature Genemodel or SimFeature object (genemodel, cDNA, 
     *     Blast)
     * @param _location location on sequence
     */
    public  Intron(GFMergeFeature _gfmFeature, Location _location)
    {
      super(_gfmFeature, _location);
    } // end Intron

    ///////////////////////////////////////
    // operations

} // end Intron
