package uk.ac.sanger.psu.gfmerge.datacomp;

import java.util.*;
import org.biojava.bio.seq.*;
import org.biojava.bio.symbol.*;

import uk.ac.sanger.psu.gfmerge.util.biotools.*;
import uk.ac.sanger.psu.gfmerge.datacomp.*;

/** class is representing a similarity feature used as evidence for correct predictions. 
 * <p>
 * This class wraps the BioJava Feature class and contains feature hits. Those hits are either a Blast or a cDNA feature.
 * For example:
 * <pre>
 * SimFeature simFeature = new SimFeature(feature);
 * </pre>
 * 
 * @author Sebastian R. Spiegler
 * @see uk.ac.sanger.psu.gfmerge.datacomp.GeneModel
 * @see uk.ac.sanger.psu.gfmerge.datacomp.LocateAble
 * @version 1.0
 */

public class SimFeature extends GFMergeFeature{

  ///////////////////////////////////////
  // attributes



  ///////////////////////////////////////
  // constructor

  /** constructor for SimFeature objects
   * 
   * @param feature BioJava feature object
   */
  public SimFeature(StrandedFeature feature)
  {
    super(feature);
  }
} // end
