package uk.ac.sanger.psu.gfmerge.util.io;

import org.biojava.bio.*;
import org.biojava.bio.seq.*;
import org.biojava.bio.seq.io.*;
import java.io.*;
import java.util.*;

/** class which reads EMBL files into objects using SeqIOTools.readEmbl().
 */
public class GFMergeInput
{
  /** method which returns a BioJava SequenceIterator.
   *
   * @param fname filename of EMBL file
   * @return BioJava SequenceIterator
   */
  public static SequenceIterator getSeq (String fname)
  {
    BufferedReader br = null;

    try {

      //create a buffered reader to read the sequence file
      br = new BufferedReader(new FileReader(fname));

    }
    catch (FileNotFoundException ex) {
      //can't find the file specified by fname
      ex.printStackTrace();
      System.exit(-1);
    }

    //read the EMBL File
    SequenceIterator sequences = SeqIOTools.readEmbl(br);

    return sequences;
  }
}
