/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.lsf;

/**
 * <code>JNIException</code> is an exception thrown when a serious
 * problem has occurred at the C API level. Its purpose is to make the
 * Java layer aware that valid behaviour can no longer be expected
 * from the native method call.
 *
 * @author Keith James
 */
public class JNIException extends Exception
{
    /**
     * Creates a <code>JNIException</code> with no detail
     * message.
     */
    public JNIException()
    {
        super();
    }

    /**
     * Creates an <code>JNIException</code> with the specified detail
     * message.
     *
     * @param message a <code>String</code>.
     */
    public JNIException(String message)
    {
        super(message);
    }
}
