
package uk.ac.sanger.jcon.servlets;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.PropertyConfigurator;

/**
 * <code>Log4jInitServlet</code> sets up a log4j log file defined in
 * the servlet configuration under the init parameter
 * "log4j-properties-file".
 *
 * @author Keith James
 */
public class Log4jInitServlet extends HttpServlet
{
    public void init()
    { 
        String path     = getServletContext().getRealPath("/");
        String fileName = getInitParameter("log4j-properties-file");

        if (fileName == null)
            System.err.println("WARNING: servlet init parameter 'log4j-properties-file' was not set");
        else
            PropertyConfigurator.configure(path + fileName);
    }

    public void doGet(HttpServletRequest  request,
                      HttpServletResponse response) { }
}
