/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.servlets;

import org.apache.velocity.Template;
import org.apache.velocity.context.Context;

/**
 * <code>TemplateFactory</code> is an interface for classes which
 * create Velocity populated templates.
 *
 * @author Keith James
 */
interface TemplateFactory
{
    /**
     * <code>createTemplate</code> creates a new template.
     *
     * @param context a <code>Context</code> containing data to
     * substitute.
     *
     * @return a <code>Template</code> to expand.
     *
     * @exception Exception if an error occurs
     */
    Template createTemplate(Context context) throws Exception;
}
