/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.xml;

import java.sql.Timestamp;

/**
 * <code>Converter</code> performs data type conversions for JAXB
 * (un)marshalling.
 *
 * @author Keith James
 */
public class Converter
{
    /**
     * <code>parseTimestamp</code> parses a JDBC timestamp escape
     * format stamp.
     *
     * @param s a <code>String</code>.
     *
     * @return a <code>Timestamp</code>.
     */
    public static Timestamp parseTimestamp(String s)
    {
        return Timestamp.valueOf(s);
    }

    /**
     * <code>printTimestamp</code> creates a JDBC timestamp escape
     * format stamp.
     *
     * @param t a <code>Timestamp</code>.
     *
     * @return a <code>String</code>.
     */
    public static String printTimestamp(Timestamp t)
    {
        return t.toString();
    }
}
