
package uk.ac.sanger.jcon.xml.jaxb;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.DuplicateAttributeException;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingAttributeException;
import javax.xml.bind.NoValueException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class ExecutableDO
    extends MarshallableObject
    implements Element
{

    private int _Id;
    private boolean has_Id;
    private String _Version;
    private String _Name;
    private String _Description;

    public int getId() {
        if (has_Id) {
            return _Id;
        }
        throw new NoValueException("id");
    }

    public void setId(int _Id) {
        this._Id = _Id;
        has_Id = true;
        invalidate();
    }

    public boolean hasId() {
        return has_Id;
    }

    public void deleteId() {
        has_Id = false;
        invalidate();
    }

    public String getVersion() {
        return _Version;
    }

    public void setVersion(String _Version) {
        this._Version = _Version;
        if (_Version == null) {
            invalidate();
        }
    }

    public String getName() {
        return _Name;
    }

    public void setName(String _Name) {
        this._Name = _Name;
        if (_Name == null) {
            invalidate();
        }
    }

    public String getDescription() {
        return _Description;
    }

    public void setDescription(String _Description) {
        this._Description = _Description;
        if (_Description == null) {
            invalidate();
        }
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (!has_Id) {
            throw new MissingAttributeException("id");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("Executable");
        w.attribute("id", Integer.toString(getId()));
        if (_Version!= null) {
            w.attribute("version", _Version.toString());
        }
        if (_Name!= null) {
            w.leaf("name", _Name.toString());
        }
        if (_Description!= null) {
            w.leaf("description", _Description.toString());
        }
        w.end("Executable");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("Executable");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            if (an.equals("id")) {
                if (has_Id) {
                    throw new DuplicateAttributeException(an);
                }
                try {
                    _Id = Integer.parseInt(xs.takeAttributeValue());
                } catch (Exception x) {
                    throw new ConversionException(an, x);
                }
                has_Id = true;
                continue;
            }
            if (an.equals("version")) {
                if (_Version!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _Version = xs.takeAttributeValue();
                continue;
            }
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("name")) {
            xs.takeStart("name");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Name = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("name", x);
            }
            xs.takeEnd("name");
        }
        if (xs.atStart("description")) {
            xs.takeStart("description");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Description = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("description", x);
            }
            xs.takeEnd("description");
        }
        xs.takeEnd("Executable");
    }

    public static ExecutableDO unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static ExecutableDO unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static ExecutableDO unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((ExecutableDO) d.unmarshal(xs, (ExecutableDO.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof ExecutableDO)) {
            return false;
        }
        ExecutableDO tob = ((ExecutableDO) ob);
        if (has_Id) {
            if (!tob.has_Id) {
                return false;
            }
            if (_Id!= tob._Id) {
                return false;
            }
        } else {
            if (tob.has_Id) {
                return false;
            }
        }
        if (_Version!= null) {
            if (tob._Version == null) {
                return false;
            }
            if (!_Version.equals(tob._Version)) {
                return false;
            }
        } else {
            if (tob._Version!= null) {
                return false;
            }
        }
        if (_Name!= null) {
            if (tob._Name == null) {
                return false;
            }
            if (!_Name.equals(tob._Name)) {
                return false;
            }
        } else {
            if (tob._Name!= null) {
                return false;
            }
        }
        if (_Description!= null) {
            if (tob._Description == null) {
                return false;
            }
            if (!_Description.equals(tob._Description)) {
                return false;
            }
        } else {
            if (tob._Description!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((31 *h)+ _Id);
        h = ((127 *h)+((_Version!= null)?_Version.hashCode(): 0));
        h = ((127 *h)+((_Name!= null)?_Name.hashCode(): 0));
        h = ((127 *h)+((_Description!= null)?_Description.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<Executable");
        if (has_Id) {
            sb.append(" id=");
            sb.append(Integer.toString(_Id));
        }
        if (_Version!= null) {
            sb.append(" version=");
            sb.append(_Version.toString());
        }
        if (_Name!= null) {
            sb.append(" name=");
            sb.append(_Name.toString());
        }
        if (_Description!= null) {
            sb.append(" description=");
            sb.append(_Description.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return BatchJobDO.newDispatcher();
    }

}
