
package uk.ac.sanger.jcon.xml.jaxb;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.DuplicateAttributeException;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingAttributeException;
import javax.xml.bind.NoValueException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class OwnerDO
    extends MarshallableObject
    implements Element
{

    private int _Id;
    private boolean has_Id;
    private String _UserName;
    private String _FirstName;
    private String _LastName;
    private String _EMail;
    private String _Telephone;

    public int getId() {
        if (has_Id) {
            return _Id;
        }
        throw new NoValueException("id");
    }

    public void setId(int _Id) {
        this._Id = _Id;
        has_Id = true;
        invalidate();
    }

    public boolean hasId() {
        return has_Id;
    }

    public void deleteId() {
        has_Id = false;
        invalidate();
    }

    public String getUserName() {
        return _UserName;
    }

    public void setUserName(String _UserName) {
        this._UserName = _UserName;
        if (_UserName == null) {
            invalidate();
        }
    }

    public String getFirstName() {
        return _FirstName;
    }

    public void setFirstName(String _FirstName) {
        this._FirstName = _FirstName;
        if (_FirstName == null) {
            invalidate();
        }
    }

    public String getLastName() {
        return _LastName;
    }

    public void setLastName(String _LastName) {
        this._LastName = _LastName;
        if (_LastName == null) {
            invalidate();
        }
    }

    public String getEMail() {
        return _EMail;
    }

    public void setEMail(String _EMail) {
        this._EMail = _EMail;
        if (_EMail == null) {
            invalidate();
        }
    }

    public String getTelephone() {
        return _Telephone;
    }

    public void setTelephone(String _Telephone) {
        this._Telephone = _Telephone;
        if (_Telephone == null) {
            invalidate();
        }
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (!has_Id) {
            throw new MissingAttributeException("id");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("Owner");
        w.attribute("id", Integer.toString(getId()));
        if (_UserName!= null) {
            w.leaf("userName", _UserName.toString());
        }
        if (_FirstName!= null) {
            w.leaf("firstName", _FirstName.toString());
        }
        if (_LastName!= null) {
            w.leaf("lastName", _LastName.toString());
        }
        if (_EMail!= null) {
            w.leaf("eMail", _EMail.toString());
        }
        if (_Telephone!= null) {
            w.leaf("telephone", _Telephone.toString());
        }
        w.end("Owner");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("Owner");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            if (an.equals("id")) {
                if (has_Id) {
                    throw new DuplicateAttributeException(an);
                }
                try {
                    _Id = Integer.parseInt(xs.takeAttributeValue());
                } catch (Exception x) {
                    throw new ConversionException(an, x);
                }
                has_Id = true;
                continue;
            }
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("userName")) {
            xs.takeStart("userName");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _UserName = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("userName", x);
            }
            xs.takeEnd("userName");
        }
        if (xs.atStart("firstName")) {
            xs.takeStart("firstName");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _FirstName = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("firstName", x);
            }
            xs.takeEnd("firstName");
        }
        if (xs.atStart("lastName")) {
            xs.takeStart("lastName");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _LastName = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("lastName", x);
            }
            xs.takeEnd("lastName");
        }
        if (xs.atStart("eMail")) {
            xs.takeStart("eMail");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _EMail = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("eMail", x);
            }
            xs.takeEnd("eMail");
        }
        if (xs.atStart("telephone")) {
            xs.takeStart("telephone");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Telephone = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("telephone", x);
            }
            xs.takeEnd("telephone");
        }
        xs.takeEnd("Owner");
    }

    public static OwnerDO unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static OwnerDO unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static OwnerDO unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((OwnerDO) d.unmarshal(xs, (OwnerDO.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof OwnerDO)) {
            return false;
        }
        OwnerDO tob = ((OwnerDO) ob);
        if (has_Id) {
            if (!tob.has_Id) {
                return false;
            }
            if (_Id!= tob._Id) {
                return false;
            }
        } else {
            if (tob.has_Id) {
                return false;
            }
        }
        if (_UserName!= null) {
            if (tob._UserName == null) {
                return false;
            }
            if (!_UserName.equals(tob._UserName)) {
                return false;
            }
        } else {
            if (tob._UserName!= null) {
                return false;
            }
        }
        if (_FirstName!= null) {
            if (tob._FirstName == null) {
                return false;
            }
            if (!_FirstName.equals(tob._FirstName)) {
                return false;
            }
        } else {
            if (tob._FirstName!= null) {
                return false;
            }
        }
        if (_LastName!= null) {
            if (tob._LastName == null) {
                return false;
            }
            if (!_LastName.equals(tob._LastName)) {
                return false;
            }
        } else {
            if (tob._LastName!= null) {
                return false;
            }
        }
        if (_EMail!= null) {
            if (tob._EMail == null) {
                return false;
            }
            if (!_EMail.equals(tob._EMail)) {
                return false;
            }
        } else {
            if (tob._EMail!= null) {
                return false;
            }
        }
        if (_Telephone!= null) {
            if (tob._Telephone == null) {
                return false;
            }
            if (!_Telephone.equals(tob._Telephone)) {
                return false;
            }
        } else {
            if (tob._Telephone!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((31 *h)+ _Id);
        h = ((127 *h)+((_UserName!= null)?_UserName.hashCode(): 0));
        h = ((127 *h)+((_FirstName!= null)?_FirstName.hashCode(): 0));
        h = ((127 *h)+((_LastName!= null)?_LastName.hashCode(): 0));
        h = ((127 *h)+((_EMail!= null)?_EMail.hashCode(): 0));
        h = ((127 *h)+((_Telephone!= null)?_Telephone.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<Owner");
        if (has_Id) {
            sb.append(" id=");
            sb.append(Integer.toString(_Id));
        }
        if (_UserName!= null) {
            sb.append(" userName=");
            sb.append(_UserName.toString());
        }
        if (_FirstName!= null) {
            sb.append(" firstName=");
            sb.append(_FirstName.toString());
        }
        if (_LastName!= null) {
            sb.append(" lastName=");
            sb.append(_LastName.toString());
        }
        if (_EMail!= null) {
            sb.append(" eMail=");
            sb.append(_EMail.toString());
        }
        if (_Telephone!= null) {
            sb.append(" telephone=");
            sb.append(_Telephone.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return BatchJobDO.newDispatcher();
    }

}
