
package uk.ac.sanger.jcon.xml.jaxb;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.DuplicateAttributeException;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingAttributeException;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.NoValueException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;
import uk.ac.sanger.jcon.xml.jaxb.OwnerDO;
import uk.ac.sanger.jcon.xml.jaxb.SubmissionTime;


public class TaskDO
    extends MarshallableObject
    implements Element
{

    private int _Id;
    private boolean has_Id;
    private int _Priority;
    private boolean has_Priority;
    private String _Name;
    private String _Description;
    private OwnerDO _OwnerDO;
    private MarshallableObject[] _JobProperty;
    private SubmissionTime _SubmissionTimeDO;

    public int getId() {
        if (has_Id) {
            return _Id;
        }
        throw new NoValueException("id");
    }

    public void setId(int _Id) {
        this._Id = _Id;
        has_Id = true;
        invalidate();
    }

    public boolean hasId() {
        return has_Id;
    }

    public void deleteId() {
        has_Id = false;
        invalidate();
    }

    public int getPriority() {
        if (has_Priority) {
            return _Priority;
        }
        throw new NoValueException("priority");
    }

    public void setPriority(int _Priority) {
        this._Priority = _Priority;
        has_Priority = true;
        invalidate();
    }

    public boolean hasPriority() {
        return has_Priority;
    }

    public void deletePriority() {
        has_Priority = false;
        invalidate();
    }

    public String getName() {
        return _Name;
    }

    public void setName(String _Name) {
        this._Name = _Name;
        if (_Name == null) {
            invalidate();
        }
    }

    public String getDescription() {
        return _Description;
    }

    public void setDescription(String _Description) {
        this._Description = _Description;
        if (_Description == null) {
            invalidate();
        }
    }

    public OwnerDO getOwnerDO() {
        return _OwnerDO;
    }

    public void setOwnerDO(OwnerDO _OwnerDO) {
        this._OwnerDO = _OwnerDO;
        if (_OwnerDO == null) {
            invalidate();
        }
    }

    public MarshallableObject[] getJobProperty() {
        MarshallableObject[] tmp = new MarshallableObject[_JobProperty.length] ;
        System.arraycopy(_JobProperty, 0, tmp, 0, _JobProperty.length);
        return tmp;
    }

    public void setJobProperty(MarshallableObject[] _JobProperty) {
        this._JobProperty = new MarshallableObject[_JobProperty.length] ;
        System.arraycopy(_JobProperty, 0, this._JobProperty, 0, _JobProperty.length);
        if (_JobProperty == null) {
            invalidate();
        }
    }

    public SubmissionTime getSubmissionTimeDO() {
        return _SubmissionTimeDO;
    }

    public void setSubmissionTimeDO(SubmissionTime _SubmissionTimeDO) {
        this._SubmissionTimeDO = _SubmissionTimeDO;
        if (_SubmissionTimeDO == null) {
            invalidate();
        }
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (!has_Priority) {
            throw new MissingAttributeException("priority");
        }
        if (_Name == null) {
            throw new MissingContentException("name");
        }
        if (_Description == null) {
            throw new MissingContentException("description");
        }
        if (_OwnerDO == null) {
            throw new MissingContentException("Owner");
        }
        if (_JobProperty == null) {
            throw new MissingContentException("JobProperty");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
        v.validate(_OwnerDO);
        for (int i = 0; (i<_JobProperty.length); i ++) {
            v.validate(_JobProperty[i]);
        }
        v.validate(_SubmissionTimeDO);
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("Task");
        if (has_Id) {
            w.attribute("id", Integer.toString(getId()));
        }
        w.attribute("priority", Integer.toString(getPriority()));
        w.leaf("name", _Name.toString());
        w.leaf("description", _Description.toString());
        m.marshal(_OwnerDO);
        for (int i = 0; (i<_JobProperty.length); i ++) {
            m.marshal(_JobProperty[i]);
        }
        if (_SubmissionTimeDO!= null) {
            m.marshal(_SubmissionTimeDO);
        }
        w.end("Task");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("Task");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            if (an.equals("id")) {
                if (has_Id) {
                    throw new DuplicateAttributeException(an);
                }
                try {
                    _Id = Integer.parseInt(xs.takeAttributeValue());
                } catch (Exception x) {
                    throw new ConversionException(an, x);
                }
                has_Id = true;
                continue;
            }
            if (an.equals("priority")) {
                if (has_Priority) {
                    throw new DuplicateAttributeException(an);
                }
                try {
                    _Priority = Integer.parseInt(xs.takeAttributeValue());
                } catch (Exception x) {
                    throw new ConversionException(an, x);
                }
                has_Priority = true;
                continue;
            }
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("name")) {
            xs.takeStart("name");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Name = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("name", x);
            }
            xs.takeEnd("name");
        }
        if (xs.atStart("description")) {
            xs.takeStart("description");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Description = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("description", x);
            }
            xs.takeEnd("description");
        }
        _OwnerDO = ((OwnerDO) u.unmarshal());
        {
            List l = new ArrayList();
            while (xs.atStart("Job")||xs.atStart("BatchJob")) {
                l.add(((MarshallableObject) u.unmarshal()));
            }
            _JobProperty = ((MarshallableObject[]) l.toArray(new MarshallableObject[] { }));
        }
        if (xs.atStart("submissionTime")) {
            _SubmissionTimeDO = ((SubmissionTime) u.unmarshal());
        }
        xs.takeEnd("Task");
    }

    public static TaskDO unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static TaskDO unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static TaskDO unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((TaskDO) d.unmarshal(xs, (TaskDO.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof TaskDO)) {
            return false;
        }
        TaskDO tob = ((TaskDO) ob);
        if (has_Id) {
            if (!tob.has_Id) {
                return false;
            }
            if (_Id!= tob._Id) {
                return false;
            }
        } else {
            if (tob.has_Id) {
                return false;
            }
        }
        if (has_Priority) {
            if (!tob.has_Priority) {
                return false;
            }
            if (_Priority!= tob._Priority) {
                return false;
            }
        } else {
            if (tob.has_Priority) {
                return false;
            }
        }
        if (_Name!= null) {
            if (tob._Name == null) {
                return false;
            }
            if (!_Name.equals(tob._Name)) {
                return false;
            }
        } else {
            if (tob._Name!= null) {
                return false;
            }
        }
        if (_Description!= null) {
            if (tob._Description == null) {
                return false;
            }
            if (!_Description.equals(tob._Description)) {
                return false;
            }
        } else {
            if (tob._Description!= null) {
                return false;
            }
        }
        if (_OwnerDO!= null) {
            if (tob._OwnerDO == null) {
                return false;
            }
            if (!_OwnerDO.equals(tob._OwnerDO)) {
                return false;
            }
        } else {
            if (tob._OwnerDO!= null) {
                return false;
            }
        }
        {
            MarshallableObject[] a = tob.getJobProperty();
            if (a.length!= _JobProperty.length) {
                return false;
            }
            for (int i = 0; (i<_JobProperty.length); i ++) {
                if (a[i]!= null) {
                    if (_JobProperty[i] == null) {
                        return false;
                    }
                    if (!a[i].equals(_JobProperty[i])) {
                        return false;
                    }
                } else {
                    if (_JobProperty[i]!= null) {
                        return false;
                    }
                }
            }
        }
        if (_SubmissionTimeDO!= null) {
            if (tob._SubmissionTimeDO == null) {
                return false;
            }
            if (!_SubmissionTimeDO.equals(tob._SubmissionTimeDO)) {
                return false;
            }
        } else {
            if (tob._SubmissionTimeDO!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((31 *h)+ _Id);
        h = ((31 *h)+ _Priority);
        h = ((127 *h)+((_Name!= null)?_Name.hashCode(): 0));
        h = ((127 *h)+((_Description!= null)?_Description.hashCode(): 0));
        h = ((127 *h)+((_OwnerDO!= null)?_OwnerDO.hashCode(): 0));
        if (_JobProperty!= null) {
            for (int i = 0; (i<_JobProperty.length); i ++) {
                h = ((127 *h)+ _JobProperty[i].hashCode());
            }
        }
        h = ((127 *h)+((_SubmissionTimeDO!= null)?_SubmissionTimeDO.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<Task");
        if (has_Id) {
            sb.append(" id=");
            sb.append(Integer.toString(_Id));
        }
        if (has_Priority) {
            sb.append(" priority=");
            sb.append(Integer.toString(_Priority));
        }
        if (_Name!= null) {
            sb.append(" name=");
            sb.append(_Name.toString());
        }
        if (_Description!= null) {
            sb.append(" description=");
            sb.append(_Description.toString());
        }
        if (_OwnerDO!= null) {
            sb.append(" Owner=");
            sb.append(_OwnerDO.toString());
        }
        if ((_JobProperty!= null)&&(_JobProperty.length > 0)) {
            sb.append(" JobProperty=[");
            boolean first = true;
            for (int i = 0; (i<_JobProperty.length); i ++) {
                if (!first) {
                    sb.append(" ");
                }
                sb.append(_JobProperty[i].toString());
                first = false;
            }
            sb.append("]");
        }
        if (_SubmissionTimeDO!= null) {
            sb.append(" submissionTime=");
            sb.append(_SubmissionTimeDO.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return BatchJobDO.newDispatcher();
    }

}
