/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon;

import java.io.File;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.sql.DataSource;

import org.dbunit.DatabaseTestCase;
import org.dbunit.database.DatabaseDataSourceConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.xml.FlatXmlDataSet;

public class JobControlSQLCase extends DatabaseTestCase
{
    protected DataSource datasource;

    public JobControlSQLCase(String name) throws Exception
    {
        super(name);

        Context context = new InitialContext();
        datasource = (DataSource) context.lookup("jdbc/TestJobControl");
    }

    protected IDatabaseConnection getConnection() throws Exception
    {
        return new DatabaseDataSourceConnection(datasource);
    }

    protected IDataSet getDataSet() throws Exception
    {
        String fileName = getClass().getResource("/jobcontrol_data_oracle.xml").getFile();

        return new FlatXmlDataSet(new File(fileName));
    }
}
