/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.dao;

import java.util.Collection;

import uk.ac.sanger.jcon.JobControlSQLCase;
import uk.ac.sanger.jcon.job.Executable;

/**
 * <code>ExecutableSQLDAOTest</code> tests create, read, update and
 * delete of <code>Executable</code>s.
 *
 * @author Keith James
 */
public class ExecutableSQLDAOTest extends JobControlSQLCase
{
    private ExecutableSQLDAO executableSQLDAO;

    public ExecutableSQLDAOTest(String name) throws Exception
    {
        super(name);
    }

    public void testReadAllExecutables() throws Exception
    {
        executableSQLDAO = new ExecutableSQLDAO(datasource);

        Collection executables = executableSQLDAO.readAllExecutables();
        assertEquals(3, executables.size());
    }

    public void testReadExecutableById() throws Exception
    {
        executableSQLDAO = new ExecutableSQLDAO(datasource);

        Executable executable = executableSQLDAO.readExecutableById(1);
        assertEquals(1, executable.getId());
        assertEquals("sleeper10.sh", executable.getName());
        assertEquals("1.0", executable.getVersion());
        assertEquals("Sleeps for 10 seconds", executable.getDescription());
    }
}
