/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.dao;

import java.util.Collection;

import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.operation.DatabaseOperation;

import uk.ac.sanger.jcon.JobControlSQLCase;
import uk.ac.sanger.jcon.job.Owner;

/**
 * <code>OwnerSQLDAOTest</code> tests create, read, update and delete
 * of <code>Owner</code>s.
 *
 * @author Keith James
 */
public class OwnerSQLDAOTest extends JobControlSQLCase
{
    private OwnerSQLDAO ownerSQLDAO;

    public OwnerSQLDAOTest(String name) throws Exception
    {
        super(name);
    }

    public void testReadAllOwners() throws Exception
    {
        ownerSQLDAO = new OwnerSQLDAO(datasource);

        Collection owners = ownerSQLDAO.readAllOwners();
        assertEquals(1, owners.size());
    }

    public void testReadOwnerById() throws Exception
    {
        ownerSQLDAO = new OwnerSQLDAO(datasource);

        Owner o = ownerSQLDAO.readOwnerById(1);
        assertEquals(1, o.getId());
        assertEquals("another", o.getUserName());
        assertEquals("Anne", o.getFirstName());
        assertEquals("Other", o.getLastName());
        assertEquals("another@other.org", o.getEMail());
        assertEquals("123456", o.getTelephone());
    }
}
