/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.dao;

import java.util.Collection;

import uk.ac.sanger.jcon.JobControlSQLCase;
import uk.ac.sanger.jcon.job.Status;

/**
 * <code>StatusSQLDAOTest</code> tests reading of <code>Status</code>.
 *
 * @author Keith James
 */
public class StatusSQLDAOTest extends JobControlSQLCase
{
    private StatusSQLDAO statusSQLDAO;

    public StatusSQLDAOTest(String name) throws Exception
    {
        super(name);
    }

    public void testReadAllStatus() throws Exception
    {
        statusSQLDAO = new StatusSQLDAO(datasource);

        Collection status = statusSQLDAO.readAllStatus();
        assertEquals(7, status.size());
    }

    public void testReadStatusById() throws Exception
    {
        statusSQLDAO = new StatusSQLDAO(datasource);

        Status status = statusSQLDAO.readStatusById(Status.WAITING);
        assertEquals(1, status.getId());
        assertEquals("WAITING", status.getDescription());
    }
}
