/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.job;

import junit.framework.TestCase;

/**
 * <code>JobDefaultImplTest</code> tests <code>Job</code> structure.
 *
 * @author Keith James
 */
public class JobDefaultImplTest extends TestCase
{
    // Test set of jobs
    private JobDefaultImpl [] jobs = { new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl(),
                                       new JobDefaultImpl() };

    public JobDefaultImplTest(String name)
    {
        super(name);
    }

    public void testCreateTree()
    {
        jobs[0].add(jobs[1]);
        jobs[0].add(jobs[2]);
        jobs[0].add(jobs[3]);

        jobs[2].add(jobs[4]);
        jobs[2].add(jobs[5]);

        jobs[3].add(jobs[6]);

        jobs[5].add(jobs[7]);
        jobs[5].add(jobs[8]);
        jobs[5].add(jobs[9]);

        jobs[6].add(jobs[10]);
        jobs[6].add(jobs[11]);

        assertTrue(! jobs[0].isLeaf());
        assertTrue(  jobs[1].isLeaf());
        assertTrue(! jobs[2].isLeaf());
        assertTrue(! jobs[3].isLeaf());
        assertTrue(  jobs[4].isLeaf());
        assertTrue(! jobs[5].isLeaf());
        assertTrue(! jobs[6].isLeaf());
        assertTrue(  jobs[7].isLeaf());
        assertTrue(  jobs[8].isLeaf());
        assertTrue(  jobs[9].isLeaf());
        assertTrue(  jobs[10].isLeaf());
        assertTrue(  jobs[11].isLeaf());

        assertEquals(jobs[0], jobs[1].getParent());
        assertEquals(jobs[0], jobs[2].getParent());
        assertEquals(jobs[0], jobs[3].getParent());

        assertEquals(jobs[2], jobs[4].getParent());
        assertEquals(jobs[2], jobs[5].getParent());

        assertEquals(jobs[3], jobs[6].getParent());

        assertEquals(jobs[5], jobs[7].getParent());
        assertEquals(jobs[5], jobs[8].getParent());
        assertEquals(jobs[5], jobs[9].getParent());

        assertEquals(jobs[6], jobs[10].getParent());
        assertEquals(jobs[6], jobs[11].getParent());
    }
}
