/*
 * Copyright (c) 2002 Genome Research Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published 
 * by  the Free Software Foundation; either version 2 of the License or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.LIB.  If not, write to 
 * the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
 * Boston, MA  02111-1307 USA
 */

package uk.ac.sanger.jcon.run;

import uk.ac.sanger.jcon.run.Policy;

/**
 * <code>SingleTaskPolicy</code> is a policy which only return the
 * same <code>Task</code> ID every time.
 *
 * @author Keith James
 */
public class SingleTaskPolicy implements Policy
{
    private int taskId;

    /**
     * Creates a new <code>SingleTaskPolicy</code> which returns the
     * specified ID.
     *
     * @param taskId an <code>int</code> ID.
     */
    public SingleTaskPolicy(int taskId)
    {
        this.taskId = taskId;
    }

    public int selectTaskId()
    {
        return taskId;
    }
}
