#!/usr/local/bin/perl

##########################################################################
#
# This script runs caf2phrap for the unique caf file foreach directory, 
# part of the root directory specified in the command line 
#
# It generates a new file, within the root directory, with all the sequences reads
# 
##########################################################################

use strict;

my $root_directory = "/nfs/teams/team23";
my $tmp_directory = "/tmp";
my $output_file_name = "strept_reads";

my $lg = @ARGV + 0;
if ($lg >= 1) {
  $root_directory = $ARGV[0];
}
else {
  print "ERROR - specify the name of a directory\n";
  print "Syntax : perl caf2phrap_all.pl [root_directory_name]\n";
  exit 1;
}

# index of all directories - syntax : "*St*"

opendir (THISDIR, $root_directory) or die "can not read this directory ...";

my @directory_index = map {$root_directory."/".$_} grep {$_ =~ /(.*)St(.*)/} readdir THISDIR;
closedir THISDIR;
my $i = 0;
my @args;

# for each directory run caf2phrap script for the "caf.raw" file
# the ouput is forwarded into a temporary file
 
foreach my $directory (@directory_index) {
  my $output_file = $tmp_directory . "/" . $output_file_name . $i . "_tmp";
  $directory = $directory . "/CAF/";
  my $input_file = $directory . "caf.raw";
  @args = ("caf2phrap -fasta $output_file < $input_file");
  system (@args);
  @args = ();
  # delete tmp.* files
  $args[0] = "rm -f " . $output_file . ".*";
  system (@args);
  $i ++;
}

my $output_file = $tmp_directory . "/" . $output_file_name;
my $output_file_tmp = $tmp_directory . "/" . $output_file_name . "0_tmp";

@args = ("rm -f $output_file");
system (@args);

@args = ("cat $output_file_tmp > $output_file");
# @args = ("cat");

my $j = 0;
while ($j < $i) {
  $output_file_tmp = $tmp_directory . "/" . $output_file_name . $j . "_tmp";
  # $args[0] = $args[0] . " " . $output_file_tmp;
  @args = ("cat $output_file_tmp >> $output_file");
  system (@args);
  $j++;
}

#$args[0] = $args[0] . " > " . $output_file;
#print ("args: $args[0]\n");
#system (@args);

@args = ();
$args[0] = "rm -f " . $tmp_directory . "/" . $output_file_name . "*_tmp*";
system (@args);
