#!/bin/sh
#
# $Header: /nfs/pathsoft/repository/psu/strepexec/shell/src/makewebgif.sh,v 1.7 2000/03/31 14:32:18 kdj Exp $
#
# author:  Keith James  kdj@sanger.ac.uk
#
# purpose: This makes a gif file from the EMBL tab file.

USAGE="Usage: makewebgif.sh COSMID"

EMBL_2_PS=/nfs/disk222/yeastpub/zoo/general/embl_to_ps.pl
MAKE_TABLE=/nfs/disk222/yeastpub/zoo/strepc/tabulate.pl

DEST_DIR=/nfs/WWW/htdocs/Projects/S_coelicolor/cosmid_gifs
COSMID_DATA=/nfs/disk222/yeastpub/analysis/strepc/admin/web_data/cosmid_table_data
COSMID_TABLE=/nfs/WWW/htdocs/Projects/S_coelicolor/cosmid_table.shtml

if [ -z "$1" ]; then
    echo $USAGE
    exit 1
fi

if [ ! -r $1.tab ]; then
    echo "Warning: unable to read $1.tab!"
    exit 1
fi

if [ ! -r $1.seq_embl ]; then
    echo "Warning: unable to read $1.seq_embl!"
    exit 1
fi

echo "Writing $1.web..."
cat $1.tab $1.seq_embl > $1.web

echo "Writing $1.ps..."
$EMBL_2_PS -feature_height=7.2 -line_base_length=10000 -font_size=9.0 -line_spacing=100 $1.web > $1.ps 2> /dev/null

echo "Writing $1.gif..."
gs -q -dBATCH -dNOPAUSE -sDEVICE=ppm -sOutputFile=temp.ppm -g1200x1500 -r125 $1.ps 2> /dev/null

ppmtogif temp.ppm > $1.gif 2> /dev/null

rm -f temp.ppm

echo "Copying gif to $DEST_DIR..."

cp $1.gif $DEST_DIR

echo "Updating $COSMID_DATA..."

echo "$1 cosmid_gifs/$1.gif" >> $COSMID_DATA

echo "Creating new cosmid HTML table..."

cp $COSMID_TABLE $COSMID_TABLE.bak

$MAKE_TABLE $COSMID_DATA > $COSMID_TABLE

